
/**
  * To test the widgets...
  * @author ric Plante
  **/

import java.applet.Applet;
import java.awt.*;
import java.net.*;
import ep.cg.widgets.*;
import ep.cg.*;

public class PolyIntersector extends Applet implements ActionListener, Runnable {

  private boolean loading_ = true;
  private Image img1_;
  private Image img2_;
  private Image img3_;
  private Image img4_;
  private Image img5_;
  private Image img6_;
  private Image img7_;
  private Image img8_;
  private Image b1_;
  private Image b2_;
  private Image b3_;
  private MediaTracker mt_;
  private Button btn_ = new Button("Redisplay applet");

  private MainFrame mf_ = null;

  public void init() {
    setBackground(new Color(88,112,72));
    loading_ = true;
    repaint(0);
    Thread t = new Thread(this);
    t.start();
  }

  public void run() {
    repaint(0);
    Thread.yield();

    img1_ = getImage( getCodeBase(), "G2.gif");
    img2_ = getImage( getCodeBase(), "G21.gif");
    img3_ = getImage( getCodeBase(), "G22.gif");
    img4_ = getImage( getCodeBase(), "G23.gif");
    img5_ = getImage( getCodeBase(), "G11.gif");
    img6_ = getImage( getCodeBase(), "G12.gif");
    img7_ = getImage( getCodeBase(), "G13.gif");
    img8_ = getImage( getCodeBase(), "G14.gif");

    b1_ = getImage( getCodeBase(), "br.gif");
    b2_ = getImage( getCodeBase(), "bo.gif");
    b3_ = getImage( getCodeBase(), "bv.gif");


    ActionPanel ap = new ActionPanel(img1_, img2_, img3_, img4_);
    ModePanel   mp = new ModePanel(  img5_, img6_, img7_, img8_);
    PolyCanvas  pc = new PolyCanvas(b1_, b2_, b3_);
    pc.resize(320,302);

    mt_ = new MediaTracker(ap);

    mt_.addImage(img1_, 0);
    mt_.addImage(img2_, 0);
    mt_.addImage(img3_, 0);
    mt_.addImage(img4_, 0);
    mt_.addImage(img5_, 0);
    mt_.addImage(img6_, 0);
    mt_.addImage(img7_, 0);
    mt_.addImage(img8_, 0);

    mt_.addImage(b1_, 0);
    mt_.addImage(b2_, 0);
    mt_.addImage(b3_, 0);

    repaint(0);
    Thread.yield();
    
    try {
      mt_.waitForID(0);
    } catch(InterruptedException  e)  {
    }

    mf_ = new MainFrame(mp, ap, pc);
    mf_.addListener(this);
    //mf_.resize(640,302);
    mf_.resize(700,400);
    mf_.show();
    mf_.resize(700,400);
    mf_.show();

    loading_ = false;
    add(btn_);
    validate();
    repaint(0);

    System.out.println("status ... "+ mt_.statusAll(true));
  }

  public void paint(Graphics g) {
    super.paint(g);
    g.setColor(getBackground());
    Dimension dim = size();
    g.fillRect(0,0,dim.width,dim.height);
    if (loading_) {
      g.setColor(Color.black);
      g.drawString("Loading user interface, please wait...", 50, 25);
    }
  }

  public void stop() {
    mf_.hide();
  }

  public void start() {
    if (loading_ == false && mf_ != null)
      mf_.show();
  }

  public void actionEvent(int act) {
    if (act == ACTION_QIT)
      stop();
  }

  public boolean action(Event evt, Object target) {
    System.out.println("ACTION");
    if (evt.target == btn_) {
      System.out.println("It's da button");
      if (loading_ == false && mf_ != null)
	mf_.show();
      return true;
    }
    return false;
  }
}
