/**
  * A segment class with two points and a group identifier. The group
  * might be used for colouring.
  */

package ep.cg;

public class Segment {

  private Point p1_;
  private Point p2_;
  private int id_;

  public Segment( Point p1, Point p2, int identifier) {
    p1_ = p1;
    p2_ = p2;
    id_ = identifier;
  }

  public final Point getP1() {
    return p1_;
  }

  public final Point getP2() {
    return p2_;
  }

  public final int getIdent() {
    return id_;
  }

  public final void setIdent(int id) {
    id_ = id;
  }

  public final boolean equals(Segment s) {
    if ( p1_ == s.p1_ && p2_ == s.p2_ && id_ == s.id_ )
      return true;
    else if ( p1_.equals(s.p1_) && p2_.equals(s.p2_) &&  id_ == s.id_ )
      return true;

    return false;
  }
  public final String toString() {
    return new String("("+p1_.x()+", "+p1_.y()+") to " +
					 "("+p2_.x()+", "+p2_.y()+")" );
    
  }
}
