package ep.cg.widgets;

import java.awt.*;
import ep.cg.ModeChangeListener;
import ep.cg.ActionListener;
import ep.cg.widgets.*;
import java.util.Vector;

/**
  * Main frame of the app.
  * @author ric Plante
  **/

public class MainFrame extends Frame implements ActionListener {

  private ActionPanel ap_;
  private ModePanel mp_;
  private PolyCanvas pc_;
  private Vector listeners_ = new Vector();

  public MainFrame( ModePanel mp, ActionPanel ap, PolyCanvas pc ) {

    mp_ = mp;
    ap_ = ap;
    pc_ = pc;

    mp_.addListener(pc_);
    ap_.addListener(this);
    ap_.addListener(pc_);
    
    //resize(640,302);

    setCursor( CROSSHAIR_CURSOR );

    BorderLayout bl  = new BorderLayout();
    BorderLayout pbl = new BorderLayout();

    setLayout(bl);
    Panel p = new Panel();
    p.setLayout(pbl);
    //p.resize(320,302);
    p.add("Center", ap_);
    Label label_ = new Label("by ric Plante, (c)1997   ", Label.RIGHT);
    label_.setFont(new Font("Helvetica", Font.PLAIN, 10));
    label_.setForeground(Color.red.darker().darker().darker());
    p.add("South", label_);
    p.add("North", mp_);
    p.validate();
    p.setBackground(Color.black);

    add("Center", pc_);
    add("West", p);

    validate();
    //resize(640,302);
  }

  public void actionEvent(int act) {
    notifyListeners(act);
  }

  public void addListener(ActionListener l) {
    if ( listeners_.indexOf(l) == -1 )
      listeners_.addElement(l);
  }

  public void removeListener(ActionListener l) {
    listeners_.removeElement(l);
  }

  public void notifyListeners(int act) {
    System.out.println("Notifying change to "+act);
    int size = listeners_.size();
    int i;

    for (i=0; i<size; i++) {
      ((ActionListener)listeners_.elementAt(i)).actionEvent(act);
    }
  }


  /**
  public Dimension minimumSize() {
    return new Dimension(640,302);
  }
  public Dimension preferredSize() {
    return new Dimension(640,302);
  }
  **/


}
